import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["value", "children", "index", "onSelect", "checkbox"];
import { cloneElement } from 'react';
import PropTypes from 'prop-types';
import isEqual from 'lodash.isequal';

var ExtendedChildren = function ExtendedChildren(_ref) {
  var value = _ref.value,
      children = _ref.children,
      index = _ref.index,
      onSelectListHandler = _ref.onSelect,
      checkbox = _ref.checkbox,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  var _children$props = children.props,
      valueChild = _children$props.value,
      onSelectOptionHandler = _children$props.onSelect,
      selectedChild = _children$props.selected,
      checkboxChild = _children$props.checkbox;
  var selected = Array.isArray(value) ? value.some(function (innerValue) {
    return isEqual(valueChild, innerValue);
  }) : isEqual(value, valueChild);

  var onSelectHandler = function onSelectHandler() {
    typeof onSelectOptionHandler === 'function' && onSelectOptionHandler.apply(void 0, arguments);
    typeof onSelectListHandler === 'function' && onSelectListHandler.apply(void 0, arguments);
  };

  return /*#__PURE__*/cloneElement(children, _extends({}, props, {
    index: index,
    selected: selectedChild === undefined ? selected : selectedChild,
    onSelect: onSelectHandler,
    checkbox: checkboxChild === undefined ? checkbox : checkboxChild
  }));
};

export default ExtendedChildren;